/* ***********************************************************
 * This file was automatically generated on 2012-09-28.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#include "bricklet_gps.h"

#include <string.h>

#define FUNCTION_GET_COORDINATES 1
#define FUNCTION_GET_STATUS 2
#define FUNCTION_RESTART 3
#define FUNCTION_SET_COORDINATES_CALLBACK_PERIOD 4
#define FUNCTION_GET_COORDINATES_CALLBACK_PERIOD 5
#define FUNCTION_SET_STATUS_CALLBACK_PERIOD 6
#define FUNCTION_GET_STATUS_CALLBACK_PERIOD 7


typedef void (*coordinates_func_t)(char, uint16_t, char, uint16_t, uint16_t, uint16_t, uint16_t);

typedef void (*status_func_t)(uint8_t, uint8_t, uint8_t, uint16_t, uint16_t, uint32_t, uint32_t, int16_t, int16_t);

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(push)
	#pragma pack(1)
	#define ATTRIBUTE_PACKED
#elif defined __GNUC__
	#define ATTRIBUTE_PACKED __attribute__((packed))
#else
	#error unknown compiler, do not know how to enable struct packing
#endif

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetCoordinates_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char ns;
	uint16_t latitude[2];
	char ew;
	uint16_t longitude[2];
	uint16_t pdop;
	uint16_t hdop;
	uint16_t vdop;
} ATTRIBUTE_PACKED GetCoordinatesReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetStatus_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t fix;
	uint8_t satellites_view;
	uint8_t satellites_used;
	uint16_t speed;
	uint16_t course;
	uint32_t date;
	uint32_t time;
	int16_t altitude;
	int16_t altitude_accuracy;
} ATTRIBUTE_PACKED GetStatusReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t restart_type;
} ATTRIBUTE_PACKED Restart_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t period;
} ATTRIBUTE_PACKED SetCoordinatesCallbackPeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetCoordinatesCallbackPeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t period;
} ATTRIBUTE_PACKED GetCoordinatesCallbackPeriodReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t period;
} ATTRIBUTE_PACKED SetStatusCallbackPeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetStatusCallbackPeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t period;
} ATTRIBUTE_PACKED GetStatusCallbackPeriodReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char ns;
	uint16_t latitude[2];
	char ew;
	uint16_t longitude[2];
	uint16_t pdop;
	uint16_t hdop;
	uint16_t vdop;
} ATTRIBUTE_PACKED CoordinatesCallback_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t fix;
	uint8_t satellites_view;
	uint8_t satellites_used;
	uint16_t speed;
	uint16_t course;
	uint32_t date;
	uint32_t time;
	int16_t altitude;
	int16_t altitude_accuracy;
} ATTRIBUTE_PACKED StatusCallback_;

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(pop)
#endif
#undef ATTRIBUTE_PACKED

int gps_get_coordinates(GPS *gps, char *ret_ns, uint16_t ret_latitude[2], char *ret_ew, uint16_t ret_longitude[2], uint16_t *ret_pdop, uint16_t *ret_hdop, uint16_t *ret_vdop) {
	if(gps->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&gps->write_mutex);

	gps->response.function_id = FUNCTION_GET_COORDINATES;
	gps->response.length = sizeof(GetCoordinatesReturn_);
	GetCoordinates_ gc;
	gc.stack_id = gps->stack_id;
	gc.function_id = FUNCTION_GET_COORDINATES;
	gc.length = ipcon_leconvert_uint16_to(sizeof(GetCoordinates_));

	ipcon_device_write(gps, (char *)&gc, sizeof(GetCoordinates_));

	if(ipcon_device_expect_response(gps) != 0) {
		ipcon_mutex_unlock(&gps->write_mutex);
		return E_TIMEOUT;
	}

	GetCoordinatesReturn_ *gcr = (GetCoordinatesReturn_ *)gps->response.buffer;
	*ret_ns = gcr->ns;
	for (int i = 0; i < 2; i++) ret_latitude[i] = ipcon_leconvert_uint16_from(gcr->latitude[i]);
	*ret_ew = gcr->ew;
	for (int i = 0; i < 2; i++) ret_longitude[i] = ipcon_leconvert_uint16_from(gcr->longitude[i]);
	*ret_pdop = ipcon_leconvert_uint16_from(gcr->pdop);
	*ret_hdop = ipcon_leconvert_uint16_from(gcr->hdop);
	*ret_vdop = ipcon_leconvert_uint16_from(gcr->vdop);

	ipcon_mutex_unlock(&gps->write_mutex);

	return E_OK;
}

int gps_get_status(GPS *gps, uint8_t *ret_fix, uint8_t *ret_satellites_view, uint8_t *ret_satellites_used, uint16_t *ret_speed, uint16_t *ret_course, uint32_t *ret_date, uint32_t *ret_time, int16_t *ret_altitude, int16_t *ret_altitude_accuracy) {
	if(gps->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&gps->write_mutex);

	gps->response.function_id = FUNCTION_GET_STATUS;
	gps->response.length = sizeof(GetStatusReturn_);
	GetStatus_ gs;
	gs.stack_id = gps->stack_id;
	gs.function_id = FUNCTION_GET_STATUS;
	gs.length = ipcon_leconvert_uint16_to(sizeof(GetStatus_));

	ipcon_device_write(gps, (char *)&gs, sizeof(GetStatus_));

	if(ipcon_device_expect_response(gps) != 0) {
		ipcon_mutex_unlock(&gps->write_mutex);
		return E_TIMEOUT;
	}

	GetStatusReturn_ *gsr = (GetStatusReturn_ *)gps->response.buffer;
	*ret_fix = gsr->fix;
	*ret_satellites_view = gsr->satellites_view;
	*ret_satellites_used = gsr->satellites_used;
	*ret_speed = ipcon_leconvert_uint16_from(gsr->speed);
	*ret_course = ipcon_leconvert_uint16_from(gsr->course);
	*ret_date = ipcon_leconvert_uint32_from(gsr->date);
	*ret_time = ipcon_leconvert_uint32_from(gsr->time);
	*ret_altitude = ipcon_leconvert_int16_from(gsr->altitude);
	*ret_altitude_accuracy = ipcon_leconvert_int16_from(gsr->altitude_accuracy);

	ipcon_mutex_unlock(&gps->write_mutex);

	return E_OK;
}

int gps_restart(GPS *gps, uint8_t restart_type) {
	if(gps->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&gps->write_mutex);

	Restart_ r;
	r.stack_id = gps->stack_id;
	r.function_id = FUNCTION_RESTART;
	r.length = ipcon_leconvert_uint16_to(sizeof(Restart_));
	r.restart_type = restart_type;

	ipcon_device_write(gps, (char *)&r, sizeof(Restart_));

	ipcon_mutex_unlock(&gps->write_mutex);

	return E_OK;
}

int gps_set_coordinates_callback_period(GPS *gps, uint32_t period) {
	if(gps->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&gps->write_mutex);

	SetCoordinatesCallbackPeriod_ sccp;
	sccp.stack_id = gps->stack_id;
	sccp.function_id = FUNCTION_SET_COORDINATES_CALLBACK_PERIOD;
	sccp.length = ipcon_leconvert_uint16_to(sizeof(SetCoordinatesCallbackPeriod_));
	sccp.period = ipcon_leconvert_uint32_to(period);

	ipcon_device_write(gps, (char *)&sccp, sizeof(SetCoordinatesCallbackPeriod_));

	ipcon_mutex_unlock(&gps->write_mutex);

	return E_OK;
}

int gps_get_coordinates_callback_period(GPS *gps, uint32_t *ret_period) {
	if(gps->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&gps->write_mutex);

	gps->response.function_id = FUNCTION_GET_COORDINATES_CALLBACK_PERIOD;
	gps->response.length = sizeof(GetCoordinatesCallbackPeriodReturn_);
	GetCoordinatesCallbackPeriod_ gccp;
	gccp.stack_id = gps->stack_id;
	gccp.function_id = FUNCTION_GET_COORDINATES_CALLBACK_PERIOD;
	gccp.length = ipcon_leconvert_uint16_to(sizeof(GetCoordinatesCallbackPeriod_));

	ipcon_device_write(gps, (char *)&gccp, sizeof(GetCoordinatesCallbackPeriod_));

	if(ipcon_device_expect_response(gps) != 0) {
		ipcon_mutex_unlock(&gps->write_mutex);
		return E_TIMEOUT;
	}

	GetCoordinatesCallbackPeriodReturn_ *gccpr = (GetCoordinatesCallbackPeriodReturn_ *)gps->response.buffer;
	*ret_period = ipcon_leconvert_uint32_from(gccpr->period);

	ipcon_mutex_unlock(&gps->write_mutex);

	return E_OK;
}

int gps_set_status_callback_period(GPS *gps, uint32_t period) {
	if(gps->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&gps->write_mutex);

	SetStatusCallbackPeriod_ sscp;
	sscp.stack_id = gps->stack_id;
	sscp.function_id = FUNCTION_SET_STATUS_CALLBACK_PERIOD;
	sscp.length = ipcon_leconvert_uint16_to(sizeof(SetStatusCallbackPeriod_));
	sscp.period = ipcon_leconvert_uint32_to(period);

	ipcon_device_write(gps, (char *)&sscp, sizeof(SetStatusCallbackPeriod_));

	ipcon_mutex_unlock(&gps->write_mutex);

	return E_OK;
}

int gps_get_status_callback_period(GPS *gps, uint32_t *ret_period) {
	if(gps->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&gps->write_mutex);

	gps->response.function_id = FUNCTION_GET_STATUS_CALLBACK_PERIOD;
	gps->response.length = sizeof(GetStatusCallbackPeriodReturn_);
	GetStatusCallbackPeriod_ gscp;
	gscp.stack_id = gps->stack_id;
	gscp.function_id = FUNCTION_GET_STATUS_CALLBACK_PERIOD;
	gscp.length = ipcon_leconvert_uint16_to(sizeof(GetStatusCallbackPeriod_));

	ipcon_device_write(gps, (char *)&gscp, sizeof(GetStatusCallbackPeriod_));

	if(ipcon_device_expect_response(gps) != 0) {
		ipcon_mutex_unlock(&gps->write_mutex);
		return E_TIMEOUT;
	}

	GetStatusCallbackPeriodReturn_ *gscpr = (GetStatusCallbackPeriodReturn_ *)gps->response.buffer;
	*ret_period = ipcon_leconvert_uint32_from(gscpr->period);

	ipcon_mutex_unlock(&gps->write_mutex);

	return E_OK;
}

int gps_get_version(GPS *gps, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]) {
	strncpy(ret_name, gps->name, 40);

	ret_firmware_version[0] = gps->firmware_version[0];
	ret_firmware_version[1] = gps->firmware_version[1];
	ret_firmware_version[2] = gps->firmware_version[2];

	ret_binding_version[0] = gps->binding_version[0];
	ret_binding_version[1] = gps->binding_version[1];
	ret_binding_version[2] = gps->binding_version[2];

	return E_OK;
}

static int gps_callback_wrapper_coordinates(GPS *gps, const unsigned char *buffer) {
	CoordinatesCallback_ *cc = (CoordinatesCallback_ *)buffer;
	for (int i = 0; i < 2; i++) cc->latitude[i] = ipcon_leconvert_uint16_from(cc->latitude[i]);
	for (int i = 0; i < 2; i++) cc->longitude[i] = ipcon_leconvert_uint16_from(cc->longitude[i]);
	cc->pdop = ipcon_leconvert_uint16_from(cc->pdop);
	cc->hdop = ipcon_leconvert_uint16_from(cc->hdop);
	cc->vdop = ipcon_leconvert_uint16_from(cc->vdop);
	((coordinates_func_t)gps->registered_callbacks[cc->function_id])(cc->ns, cc->latitude, cc->ew, cc->longitude, cc->pdop, cc->hdop, cc->vdop);
	return sizeof(CoordinatesCallback_);
}

static int gps_callback_wrapper_status(GPS *gps, const unsigned char *buffer) {
	StatusCallback_ *sc = (StatusCallback_ *)buffer;
	sc->speed = ipcon_leconvert_uint16_from(sc->speed);
	sc->course = ipcon_leconvert_uint16_from(sc->course);
	sc->date = ipcon_leconvert_uint32_from(sc->date);
	sc->time = ipcon_leconvert_uint32_from(sc->time);
	sc->altitude = ipcon_leconvert_int16_from(sc->altitude);
	sc->altitude_accuracy = ipcon_leconvert_int16_from(sc->altitude_accuracy);
	((status_func_t)gps->registered_callbacks[sc->function_id])(sc->fix, sc->satellites_view, sc->satellites_used, sc->speed, sc->course, sc->date, sc->time, sc->altitude, sc->altitude_accuracy);
	return sizeof(StatusCallback_);
}

void gps_register_callback(GPS *gps, uint8_t id, void *callback) {
	gps->registered_callbacks[id] = callback;
}

void gps_create(GPS *gps, const char *uid) {
	ipcon_device_create(gps, uid);

	gps->expected_name = "GPS Bricklet";

	gps->binding_version[0] = 1;
	gps->binding_version[1] = 0;
	gps->binding_version[2] = 0;

	gps->callback_wrappers[GPS_CALLBACK_COORDINATES] = gps_callback_wrapper_coordinates;
	gps->callback_wrappers[GPS_CALLBACK_STATUS] = gps_callback_wrapper_status;
}
