/* ***********************************************************
 * This file was automatically generated on 2012-09-28.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#include "bricklet_industrial_digital_in_4.h"

#include <string.h>

#define FUNCTION_GET_VALUE 1
#define FUNCTION_SET_GROUP 2
#define FUNCTION_GET_GROUP 3
#define FUNCTION_GET_AVAILABLE_FOR_GROUP 4
#define FUNCTION_SET_DEBOUNCE_PERIOD 5
#define FUNCTION_GET_DEBOUNCE_PERIOD 6
#define FUNCTION_SET_INTERRUPT 7
#define FUNCTION_GET_INTERRUPT 8


typedef void (*interrupt_func_t)(uint16_t, uint16_t);

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(push)
	#pragma pack(1)
	#define ATTRIBUTE_PACKED
#elif defined __GNUC__
	#define ATTRIBUTE_PACKED __attribute__((packed))
#else
	#error unknown compiler, do not know how to enable struct packing
#endif

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetValue_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t value_mask;
} ATTRIBUTE_PACKED GetValueReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char group[4];
} ATTRIBUTE_PACKED SetGroup_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetGroup_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char group[4];
} ATTRIBUTE_PACKED GetGroupReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetAvailableForGroup_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t available;
} ATTRIBUTE_PACKED GetAvailableForGroupReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t debounce;
} ATTRIBUTE_PACKED SetDebouncePeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetDebouncePeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t debounce;
} ATTRIBUTE_PACKED GetDebouncePeriodReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t interrupt_mask;
} ATTRIBUTE_PACKED SetInterrupt_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetInterrupt_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t interrupt_mask;
} ATTRIBUTE_PACKED GetInterruptReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t interrupt_mask;
	uint16_t value_mask;
} ATTRIBUTE_PACKED InterruptCallback_;

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(pop)
#endif
#undef ATTRIBUTE_PACKED

int industrial_digital_in_4_get_value(IndustrialDigitalIn4 *industrial_digital_in_4, uint16_t *ret_value_mask) {
	if(industrial_digital_in_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_in_4->write_mutex);

	industrial_digital_in_4->response.function_id = FUNCTION_GET_VALUE;
	industrial_digital_in_4->response.length = sizeof(GetValueReturn_);
	GetValue_ gv;
	gv.stack_id = industrial_digital_in_4->stack_id;
	gv.function_id = FUNCTION_GET_VALUE;
	gv.length = ipcon_leconvert_uint16_to(sizeof(GetValue_));

	ipcon_device_write(industrial_digital_in_4, (char *)&gv, sizeof(GetValue_));

	if(ipcon_device_expect_response(industrial_digital_in_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);
		return E_TIMEOUT;
	}

	GetValueReturn_ *gvr = (GetValueReturn_ *)industrial_digital_in_4->response.buffer;
	*ret_value_mask = ipcon_leconvert_uint16_from(gvr->value_mask);

	ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);

	return E_OK;
}

int industrial_digital_in_4_set_group(IndustrialDigitalIn4 *industrial_digital_in_4, char group[4]) {
	if(industrial_digital_in_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_in_4->write_mutex);

	SetGroup_ sg;
	sg.stack_id = industrial_digital_in_4->stack_id;
	sg.function_id = FUNCTION_SET_GROUP;
	sg.length = ipcon_leconvert_uint16_to(sizeof(SetGroup_));
	memcpy(sg.group, group, 4*sizeof(char));

	ipcon_device_write(industrial_digital_in_4, (char *)&sg, sizeof(SetGroup_));

	ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);

	return E_OK;
}

int industrial_digital_in_4_get_group(IndustrialDigitalIn4 *industrial_digital_in_4, char ret_group[4]) {
	if(industrial_digital_in_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_in_4->write_mutex);

	industrial_digital_in_4->response.function_id = FUNCTION_GET_GROUP;
	industrial_digital_in_4->response.length = sizeof(GetGroupReturn_);
	GetGroup_ gg;
	gg.stack_id = industrial_digital_in_4->stack_id;
	gg.function_id = FUNCTION_GET_GROUP;
	gg.length = ipcon_leconvert_uint16_to(sizeof(GetGroup_));

	ipcon_device_write(industrial_digital_in_4, (char *)&gg, sizeof(GetGroup_));

	if(ipcon_device_expect_response(industrial_digital_in_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);
		return E_TIMEOUT;
	}

	GetGroupReturn_ *ggr = (GetGroupReturn_ *)industrial_digital_in_4->response.buffer;
	memcpy(ret_group, ggr->group, 4*sizeof(char));

	ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);

	return E_OK;
}

int industrial_digital_in_4_get_available_for_group(IndustrialDigitalIn4 *industrial_digital_in_4, uint8_t *ret_available) {
	if(industrial_digital_in_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_in_4->write_mutex);

	industrial_digital_in_4->response.function_id = FUNCTION_GET_AVAILABLE_FOR_GROUP;
	industrial_digital_in_4->response.length = sizeof(GetAvailableForGroupReturn_);
	GetAvailableForGroup_ gafg;
	gafg.stack_id = industrial_digital_in_4->stack_id;
	gafg.function_id = FUNCTION_GET_AVAILABLE_FOR_GROUP;
	gafg.length = ipcon_leconvert_uint16_to(sizeof(GetAvailableForGroup_));

	ipcon_device_write(industrial_digital_in_4, (char *)&gafg, sizeof(GetAvailableForGroup_));

	if(ipcon_device_expect_response(industrial_digital_in_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);
		return E_TIMEOUT;
	}

	GetAvailableForGroupReturn_ *gafgr = (GetAvailableForGroupReturn_ *)industrial_digital_in_4->response.buffer;
	*ret_available = gafgr->available;

	ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);

	return E_OK;
}

int industrial_digital_in_4_set_debounce_period(IndustrialDigitalIn4 *industrial_digital_in_4, uint32_t debounce) {
	if(industrial_digital_in_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_in_4->write_mutex);

	SetDebouncePeriod_ sdp;
	sdp.stack_id = industrial_digital_in_4->stack_id;
	sdp.function_id = FUNCTION_SET_DEBOUNCE_PERIOD;
	sdp.length = ipcon_leconvert_uint16_to(sizeof(SetDebouncePeriod_));
	sdp.debounce = ipcon_leconvert_uint32_to(debounce);

	ipcon_device_write(industrial_digital_in_4, (char *)&sdp, sizeof(SetDebouncePeriod_));

	ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);

	return E_OK;
}

int industrial_digital_in_4_get_debounce_period(IndustrialDigitalIn4 *industrial_digital_in_4, uint32_t *ret_debounce) {
	if(industrial_digital_in_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_in_4->write_mutex);

	industrial_digital_in_4->response.function_id = FUNCTION_GET_DEBOUNCE_PERIOD;
	industrial_digital_in_4->response.length = sizeof(GetDebouncePeriodReturn_);
	GetDebouncePeriod_ gdp;
	gdp.stack_id = industrial_digital_in_4->stack_id;
	gdp.function_id = FUNCTION_GET_DEBOUNCE_PERIOD;
	gdp.length = ipcon_leconvert_uint16_to(sizeof(GetDebouncePeriod_));

	ipcon_device_write(industrial_digital_in_4, (char *)&gdp, sizeof(GetDebouncePeriod_));

	if(ipcon_device_expect_response(industrial_digital_in_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);
		return E_TIMEOUT;
	}

	GetDebouncePeriodReturn_ *gdpr = (GetDebouncePeriodReturn_ *)industrial_digital_in_4->response.buffer;
	*ret_debounce = ipcon_leconvert_uint32_from(gdpr->debounce);

	ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);

	return E_OK;
}

int industrial_digital_in_4_set_interrupt(IndustrialDigitalIn4 *industrial_digital_in_4, uint16_t interrupt_mask) {
	if(industrial_digital_in_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_in_4->write_mutex);

	SetInterrupt_ si;
	si.stack_id = industrial_digital_in_4->stack_id;
	si.function_id = FUNCTION_SET_INTERRUPT;
	si.length = ipcon_leconvert_uint16_to(sizeof(SetInterrupt_));
	si.interrupt_mask = ipcon_leconvert_uint16_to(interrupt_mask);

	ipcon_device_write(industrial_digital_in_4, (char *)&si, sizeof(SetInterrupt_));

	ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);

	return E_OK;
}

int industrial_digital_in_4_get_interrupt(IndustrialDigitalIn4 *industrial_digital_in_4, uint16_t *ret_interrupt_mask) {
	if(industrial_digital_in_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_in_4->write_mutex);

	industrial_digital_in_4->response.function_id = FUNCTION_GET_INTERRUPT;
	industrial_digital_in_4->response.length = sizeof(GetInterruptReturn_);
	GetInterrupt_ gi;
	gi.stack_id = industrial_digital_in_4->stack_id;
	gi.function_id = FUNCTION_GET_INTERRUPT;
	gi.length = ipcon_leconvert_uint16_to(sizeof(GetInterrupt_));

	ipcon_device_write(industrial_digital_in_4, (char *)&gi, sizeof(GetInterrupt_));

	if(ipcon_device_expect_response(industrial_digital_in_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);
		return E_TIMEOUT;
	}

	GetInterruptReturn_ *gir = (GetInterruptReturn_ *)industrial_digital_in_4->response.buffer;
	*ret_interrupt_mask = ipcon_leconvert_uint16_from(gir->interrupt_mask);

	ipcon_mutex_unlock(&industrial_digital_in_4->write_mutex);

	return E_OK;
}

int industrial_digital_in_4_get_version(IndustrialDigitalIn4 *industrial_digital_in_4, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]) {
	strncpy(ret_name, industrial_digital_in_4->name, 40);

	ret_firmware_version[0] = industrial_digital_in_4->firmware_version[0];
	ret_firmware_version[1] = industrial_digital_in_4->firmware_version[1];
	ret_firmware_version[2] = industrial_digital_in_4->firmware_version[2];

	ret_binding_version[0] = industrial_digital_in_4->binding_version[0];
	ret_binding_version[1] = industrial_digital_in_4->binding_version[1];
	ret_binding_version[2] = industrial_digital_in_4->binding_version[2];

	return E_OK;
}

static int industrial_digital_in_4_callback_wrapper_interrupt(IndustrialDigitalIn4 *industrial_digital_in_4, const unsigned char *buffer) {
	InterruptCallback_ *ic = (InterruptCallback_ *)buffer;
	ic->interrupt_mask = ipcon_leconvert_uint16_from(ic->interrupt_mask);
	ic->value_mask = ipcon_leconvert_uint16_from(ic->value_mask);
	((interrupt_func_t)industrial_digital_in_4->registered_callbacks[ic->function_id])(ic->interrupt_mask, ic->value_mask);
	return sizeof(InterruptCallback_);
}

void industrial_digital_in_4_register_callback(IndustrialDigitalIn4 *industrial_digital_in_4, uint8_t id, void *callback) {
	industrial_digital_in_4->registered_callbacks[id] = callback;
}

void industrial_digital_in_4_create(IndustrialDigitalIn4 *industrial_digital_in_4, const char *uid) {
	ipcon_device_create(industrial_digital_in_4, uid);

	industrial_digital_in_4->expected_name = "Industrial Digital In 4 Bricklet";

	industrial_digital_in_4->binding_version[0] = 1;
	industrial_digital_in_4->binding_version[1] = 0;
	industrial_digital_in_4->binding_version[2] = 0;

	industrial_digital_in_4->callback_wrappers[INDUSTRIAL_DIGITAL_IN_4_CALLBACK_INTERRUPT] = industrial_digital_in_4_callback_wrapper_interrupt;
}
